//------------------------------------------------------------------------------
//	єgP̋Uɓ͂Ƃ̏o͂̔g`t[GŌvZ
//
//		쐬ҁFO㒼C2013/11/13 쐬C(c)O㒼 2013
//------------------------------------------------------------------------------

#include "FourierResonator.hpp"
#include <cmath>

// ͎g킸ɋȔo͔g`t[G
void FourierResonator(const float an[], const float bn[], int maxOrder,
					  int nT0, float fr, float zeta, int16_t vn[])
{
	float PI2_T = 2.0f*3.1415926536f/(float)nT0;	// 2/T0
	float f0 = FS_/(float)nT0;						// {g

	for (int n=0; n<nT0; n++) vn[n] = 0;
	for (int k=0; k<maxOrder; k++)		// maxOrder ܂ł̘a
	{
		float kPi2T = (k + 1)*PI2_T;

		float amp = abs(ResonatorHw(f0*(k+1), fr, zeta));	// U
		float phi = arg(ResonatorHw(f0*(k+1), fr, zeta));	// ʑ

		for (int n=0; n<nT0; n++)
		{
			float theta = kPi2T*n + phi;
			vn[n] += amp*(an[k]*cosf(theta) + bn[k]*sinf(theta));
		}
	}
}

// 񋤐U̎g
Complex ResonatorHw(float w, float wr, float zeta)
{
	Complex wj = Complex(0, w);
	return wr*wr/(wj*wj + 2*zeta*wr*wj + wr*wr);
}
